program ArsClip;

uses
  Forms,
  Windows,
  SysUtils,
  Dialogs,
  UnitFrmMainPopup in 'UnitFrmMainPopup.pas' {FrmMainPopup},
  UnitFrmConfig in 'UnitFrmConfig.pas' {FrmConfig},
  UnitFrmSysTrayMenu in 'UnitFrmSysTrayMenu.pas' {frmSysTrayMenu},
  UnitFrmClipboardManager in 'UnitFrmClipboardManager.pas' {frmClipboardManager},
  UnitListBoxMover in 'UnitListBoxMover.pas',
  UnitFrmPasteSelected in 'UnitFrmPasteSelected.pas' {FrmPasteSelected},
  UnitClipQueue in 'UnitClipQueue.pas',
  UnitFrmAbout in 'UnitFrmAbout.pas' {FrmAbout},
  UnitFrmRemoved in 'UnitFrmRemoved.pas' {FrmRemoved},
  UnitOtherQueue in 'UnitOtherQueue.pas',
  UnitFrmHotKey in 'UnitFrmHotKey.pas' {FrmHotkey},
  UnitKeyboardQuery in 'UnitKeyboardQuery.pas',
  UnitFrmPreview in 'UnitFrmPreview.pas' {FrmPreview},
  UnitFrmChainWatcher in 'UnitFrmChainWatcher.pas' {FrmChainWatcher},
  UnitFrmPermanentNew in 'UnitFrmPermanentNew.pas' {FrmPermanent},
  UnitHotKey in 'UnitHotKey.pas',
  UnitTooltipPopup in 'UnitTooltipPopup.pas',
  UnitMyPopup in 'UnitMyPopup.pas',
  UnitPaste in 'UnitPaste.pas',
  UnitReportError in 'UnitReportError.pas' {FrmReportError},
  UnitMisc in 'UnitMisc.pas',
  UnitToken in 'UnitToken.pas',
  UnitTWideChar in 'UnitTWideChar.pas',
  UnitFrmDummyUnicodeTooltip in 'UnitFrmDummyUnicodeTooltip.pas' {FrmDummyUnicodeTooltip},
  UnitfrmDummyUnicodePopup in 'UnitfrmDummyUnicodePopup.pas' {FrmDummyUnicodePopup},
  UnitFrmMove in 'UnitFrmMove.pas' {FrmMove};

{$R *.res}

begin
  Application.Title := 'ArsClip';
  Application.Initialize;
  Application.ShowMainForm := False;
  Application.ShowHint := true;
  Application.CreateForm(TFrmMainPopup, FrmMainPopup);
  Application.CreateForm(TFrmHotkey, FrmHotkey);
  Application.CreateForm(TFrmAbout, FrmAbout);
  Application.CreateForm(TfrmSysTrayMenu, frmSysTrayMenu);
  Application.CreateForm(TFrmPermanent, FrmPermanent);
  Application.CreateForm(TfrmClipboardManager, frmClipboardManager);
  Application.CreateForm(TFrmPasteSelected, FrmPasteSelected);
  Application.CreateForm(TFrmRemoved, FrmRemoved);
  // unicode must be before config
  Application.CreateForm(TFrmDummyUnicodePopup, FrmDummyUnicodePopup);
  Application.CreateForm(TFrmConfig, FrmConfig);
  Application.CreateForm(TFrmPreview, FrmPreview);
  Application.CreateForm(TFrmChainWatcher, FrmChainWatcher);
  Application.CreateForm(TFrmReportError, FrmReportError);
  Application.CreateForm(TFrmDummyUnicodeTooltip, FrmDummyUnicodeTooltip);

  Application.CreateForm(TFrmMove, FrmMove);
  ShowWindow(Application.Handle, SW_HIDE);
  //
  // Keep the main form from showing
  //
  try
    Application.Run;
  except
    on E: Exception do begin
        UnitMisc.AppendLog('UNHANDLED EXCEPTION: ' + e.Message);
        UnitMisc.DumpLog('debug.txt');
        ShowMessage('ERROR: Unhandled Exception' + #13#10 +
            'The exception is being logged and a debug log has ' +
            'been created as "debug.txt". ArsClip will be closed.');
    end;
  end

end.
